Subject: Re: [Roll] definition of "RPL Domain"

From: JP Vasseur <[email-masked]>
Date: Wed, 16 Nov 2011 08:33:50 +0000

Hi Mukul,

On Oct 18, 2011, at 3:05 AM, Mukul Goyal wrote:

> Hi JP
> 
> I was wondering if the term "RPL Domain" could be defined in the terminology draft. 
> 

How about

RPL domain: set of devices using RPL as a routing protocol.

Thanks.

JP.

> Thanks
> Mukul 
> 
> ----- Forwarded Message -----
> From: "Joseph Reddy" <[email-masked]>
> To: [email-masked]
> Sent: Friday, October 14, 2011 7:15:05 PM
> Subject: Re: Fwd: I-D Action: draft-ietf-6man-rpl-option-04.txt
> 
> 
> Hi Jonathan,
> 
> The draft uses the term "RPL domain" in several places and this is not clearly defined. 
> 
> I would imagine that it includes all nodes that are downstream of the RPL border router. But can you clarify if Host nodes that are downstream of the border router but do not implement any part of RPL ( even as RPL Leaf nodes ) should be considered part of the "RPL domain" ?
> 
> In section 5, the draft now says "..Datagrams destined to nodes outside the RPL domain are dropped if the outer-most IPv6 header contains a RPL Option..."
> 
> This text would imply that any RPL node sending packets to nodes outside should always tunnel to the Root ? Is that the intention really or am I missing something here.. 
> 
> Also note that if non-RPL Host is not considered part of the RPL domain, then I am not sure that a forwarding router can know if the destination is inside the domain or not. 
> 
> 
> -Regards, Joseph
> 
> 
> ------------------------------
> 
> Message: 5
> Date: Tue, 11 Oct 2011 22:23:10 -0700
> From: Jonathan Hui <[email-masked]>
> To: IETF IPv6 Mailing List <[email-masked]>
> Subject: Fwd: I-D Action: draft-ietf-6man-rpl-option-04.txt
> Message-ID: <[email-masked]>
> Content-Type: text/plain; charset=us-ascii
> 
> 
> This update is intended to address Jari Arkko's AD review.
> 
> Summary of changes:
> - Clarify when the RPL Option is used.
> - Updated text on recommendations for avoiding fragmentation.
> - Specify skip-over-and-continue policy for unrecognized sub-TLVs.
> - Change use of IPv6-in-IPv6 tunneling from SHOULD to MUST.
> - Specify RPL Border Router operations in terms of forwarding decision outcomes.
> - Expand security section.
> 
> --
> Jonathan Hui
> 
> Begin forwarded message:
> 
>> From: [email-masked]
>> Date: October 11, 2011 10:17:15 PM PDT
>> To: [email-masked]
>> Cc: [email-masked]
>> Subject: I-D Action: draft-ietf-6man-rpl-option-04.txt
>> 
>> A New Internet-Draft is available from the on-line Internet-Drafts directories. This draft is a work item of the IPv6 Maintenance Working Group of the IETF.
>> 
>> 	Title           : RPL Option for Carrying RPL Information in Data-Plane Datagrams
>> 	Author(s)       : Jonathan W. Hui
>>                         JP Vasseur
>> 	Filename        : draft-ietf-6man-rpl-option-04.txt
>> 	Pages           : 14
>> 	Date            : 2011-10-11
>> 
>>  The RPL protocol requires data-plane datagrams to carry RPL routing
>>  information that is processed by RPL routers when forwarding those
>>  datagrams.  This document describes the RPL Option for use within a
>>  RPL domain.
>> 
>> 
>> A URL for this Internet-Draft is:
>> http://www.ietf.org/internet-drafts/draft-ietf-6man-rpl-option-04.txt
>> 
>> Internet-Drafts are also available by anonymous FTP at:
>> ftp://ftp.ietf.org/internet-drafts/
>> 
>> This Internet-Draft can be retrieved at:
>> ftp://ftp.ietf.org/internet-drafts/draft-ietf-6man-rpl-option-04.txt
>> --------------------------------------------------------------------
>> IETF IPv6 working group mailing list
>> [email-masked]
>> Administrative Requests: https://www.ietf.org/mailman/listinfo/ipv6
>> --------------------------------------------------------------------
> 
> 
> --------------------------------------------------------------------
> IETF IPv6 working group mailing list
> [email-masked]
> Administrative Requests: https://www.ietf.org/mailman/listinfo/ipv6
> --------------------------------------------------------------------

---

From: Thomas Heide Clausen <[email-masked]>
Date: Wed, 16 Nov 2011 18:40:48 +0800

Dear Jean-Philippe,

That definition doesn't really capture anything interesting or useful. 

If 40 devices are within communication range of each other, and able to form a connected graph, are they then in one "RPL domain"? Can you have these 40 devices form two RPL Domains of 20 devices each? What is the frontier between such two domains like? What impacts does it have?

If I have 20 devices running RPL here in Taiwan, and JP, you have 20 devices running RPL at home in Grenoble, but our low-power-lossy links do not allow your devices to talk to mine, do our 40 devices then form, together, an "RPL Domain"? The definition you propose allows for these 40 devices to be considered as one "RPL domain", but I am not sure that I see the usefulness of such a definition.

If the answer is "we don't know how to define it" then perhaps the definition isn't useful and the I-D should just talk about "a bunch of devices running RPL" - or the group should consider carefully formulating a helpful definition?

-- 
Thomas Heide Clausen
http://www.thomasclausen.org/

"Payload (noun): wasted bandwidth between headers" (C.Lavenu 2011)

On 16 Nov 2011, at 16:33, JP Vasseur <[email-masked]> wrote:

> _______________________________________________
> Roll mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/roll

---

From: Mukul Goyal <[email-masked]>
Date: Wed, 16 Nov 2011 04:45:57 -0600 (CST)

Hi JP

>RPL domain: set of devices using RPL as a routing protocol.

I think this definition is little too vague. Some of the points that need clarification:

1. It is clear that RPL hosts and routers (as defined towards the end of terminology section in RPL-19) are within an RPL domain but what about the RPL-unaware IPv6 hosts attached to an RPL router/host? I would imagine that such hosts are also within an RPL domain.

2. Is an RPL domain same as an RPL instance? Or is an RPL domain a set of RPL instances in the LLN? Can multiple RPL domains exist within an LLN? Or is it that an RPL domain is same as an LLN using RPL as a routing protocol?

Thanks
Mukul  

----- Original Message -----
From: "JP Vasseur" <[email-masked]>
To: "Mukul Goyal" <[email-masked]>
Cc: "roll" <[email-masked]>
Sent: Wednesday, November 16, 2011 2:33:50 AM
Subject: Re: definition of "RPL Domain"

Hi Mukul,

How about

Thanks.

JP.

---

From: Thomas Heide Clausen <[email-masked]>
Date: Wed, 16 Nov 2011 20:25:31 +0800

Now that we are at it: what is an RPL host? Or rather, why is this even a conceivable thing to define? Afaik, RPL is a routing protocol, and as such should concern only routers - not hosts?

I worry if this is inventing an entire ecosystem which "pretends to be just like the Internet, except it is not", as it needs entirely new stacks, protocols, translators/gateways everywhere, and with no real traces of IP as we know it remaining?

---

From: "Jeff Apcar (japcar)" <[email-masked]>
Date: Wed, 16 Nov 2011 23:35:56 +1100

RPL devices use IPv6, 6LowPan etc. What do you mean no real traces of IP? the whole idea is to use IP. 

Jeff.

---

From: Thomas Heide Clausen <[email-masked]>
Date: Wed, 16 Nov 2011 20:44:23 +0800

Right, I get that. But, if you start requiring that hosts be routing protocol aware, then hosts do no longer run "just IP" (albeit compressed/6low), but their applicability is tied to a specific infrastructure choice.

The purpose of the usual dichotomy between hosts and routers is to provide a layer of abstraction between applications and "connectivity maintenance". And, a layer of independence.

Requiring hosts to be aware of the intricacies of the routing protocol isn't a sound design choice - especially for the scenario that the routing protocol likely/hopefully will evolve. Effectively, in doing so, the IETF is inhibiting evolution of the routing protocol as independent from hosts and host applications.

This just isn't a valid design choice.

Would it be a good idea to have all Internet hosts, and applications thereon, require an update when a new OSPF option is introduced...?

---

From: Mukul Goyal <[email-masked]>
Date: Wed, 16 Nov 2011 07:15:59 -0600 (CST)

>Now that we are at it: what is an RPL host? Or rather, why is this even a conceivable thing to define? Afaik, RPL is a routing protocol, and as such should concern only routers - not hosts?

My bad. By RPL host, I actually meant an RPL leaf node. I think this term "RPL host" was in use at one point in time but I cant find a reference to it in current spec.

THanks
Mukul

---

From: Mukul Goyal <[email-masked]>
Date: Wed, 16 Nov 2011 07:20:34 -0600 (CST)

So, the revised doubts are as follows:

1. It is clear that RPL routers are within an RPL domain but what about the RPL-unaware IPv6 hosts attached to an RPL router? I would imagine that such hosts are also within an RPL domain.

THanks
Mukul

----- Original Message -----
From: "Mukul Goyal" <[email-masked]>
To: "Thomas Heide Clausen" <[email-masked]>
Cc: "roll" <[email-masked]>
Sent: Wednesday, November 16, 2011 7:15:59 AM
Subject: Re: [Roll] definition of "RPL Domain"

THanks
Mukul

---

From: Thomas Heide Clausen <[email-masked]>
Date: Wed, 16 Nov 2011 21:25:20 +0800

> My bad. By RPL host, I actually meant an RPL leaf node. I think this term "RPL host" was in use at one point in time but I cant find a reference to it in current spec.

A rose by any other name is *still* a rose....

What is an RPL Leaf Node? What is the difference between a RPL Leaf node and a RPL Router?

Isn't  there a thing in the end of the network, inside the LLN, that doesn't run RPL, aka, a host?

Thomas

---

From: C Chauvenet <[email-masked]>
Date: Wed, 16 Nov 2011 05:26:54 -0800

Hi Thomas,

AFAIK, "Host" is a notion that pops up in LLNs because of their contrained ressources that historical IP router don't have.

For instance, due to power limitation, a LLN device may not want to forward packets (ie act as a IP router) to save energy and achieve a reasonable lifetime.

My vision is that such Hosts will exist in all LLNs networks, regardless of the routing protocol use.
As RPL has been designed for such networks, a definition of this type of devices is needed.
If such a definition doesn't exist, then we may not be able to cope with the limitations of LLNs.

Best,
Cédric.

-----Message d'origine-----
De : [email-masked] [mailto:[email-masked]] De la part de Thomas Heide Clausen
Envoyé : mercredi 16 novembre 2011 13:26
À : Mukul Goyal
Cc : roll
Objet : Re: [Roll] definition of "RPL Domain"

On 16 Nov 2011, at 18:45, Mukul Goyal <[email-masked]> wrote:

>>> IETF IPv6 working group mailing list [email-masked] Administrative 
>>> Requests: https://www.ietf.org/mailman/listinfo/ipv6

---

From: C Chauvenet <[email-masked]>
Date: Wed, 16 Nov 2011 05:31:36 -0800

Apologize, same mistake for me, I mismatch Host and Leaf.

(My previous mail is related to RPL leaf).

Cédric.
-----Message d'origine-----
De : [email-masked] [mailto:[email-masked]] De la part de Mukul Goyal
Envoyé : mercredi 16 novembre 2011 14:16
À : Thomas Heide Clausen
Cc : roll
Objet : Re: [Roll] definition of "RPL Domain"

THanks
Mukul

---

From: Sébastien Dawans <[email-masked]>
Date: Wed, 16 Nov 2011 14:40:36 +0100

Hello Mukul,

On what ground would you assume that a non-RPL aware host connected to a 
RPL-router (in this case I would call it a border router) is in a/the 
RPL Domain?

 From what I've seen in the drafts, the term "RPL Domain"'s primary 
purpose it to differentiate the limits of "RPL-aware" nodes for IP 
traffic that needs to transit to or from a set of RPL-aware hosts (for 
example, to define where to add/remove the RPL IPv6 Hop-by-Hop Option if 
used).

To me, this interpretation of RPL Domain is thus only useful in a local 
context and not to meant to designate one or more bounded set of nodes. 
That's the role of DODAGs and Instances.

Best Regards,

Sébastien Dawans

On 11/16/2011 02:20 PM, Mukul Goyal wrote:
> From: "Mukul Goyal"<[email-masked]>
> To: "Thomas Heide Clausen"<[email-masked]>
> Cc: "roll"<[email-masked]>
> From: "Thomas Heide Clausen"<[email-masked]>
> To: "Mukul Goyal"<[email-masked]>
> Cc: "JP Vasseur"<[email-masked]>, "roll"<[email-masked]>

---

From: Jonathan Hui <[email-masked]>
Date: Wed, 16 Nov 2011 05:37:32 -0800

How about a definition derived from RFC 1629:
A "RPL domain" is a routing domain, as stated in Section 3.2 of RFC 1629, where the common routing protocol is RPL.

The above definition would unambiguously give the following answers to your questions:
1) Given the definition above, devices that do not operate RPL are not a part of the RPL domain.
2) Because RPL devices may support more than one instance, a RPL domain may contain any number of instances.

The term seems to be used most often in draft-ietf-roll-p2p-measurement.  I suggest going through and verifying whether "RPL Instance" or "RPL domain" was intended.

Happy to see any alternative definitions you may have in mind.

--
Jonathan Hui

---

From: Thomas Heide Clausen <[email-masked]>
Date: Wed, 16 Nov 2011 21:38:11 +0800

> For instance, due to power limitation, a LLN device may not want to forward packets (ie act as a IP router) to save energy and achieve a reasonable lifetime.

So, in that case, it will associate to a router and be a host - routing protocol agnostic, just like my iPad I'd unaware of whatever routing the hotel network is using.

No need to invent a new terminology for this concept.

> If such a definition doesn't exist, then we may not be able to cope with the limitations of LLNs.

I don't understand. A device that doesn't route isn't a router is therefore a host.

Requiring hosts to be "routing protocol aware" is a significant change to the Internet architecture, of which I would doubt that the Internet Architecture Board would approve.

I assert that a RPL host remains routing protocol unaware, and so is no different from a host - yes?

Thomas

---

From: Thomas Heide Clausen <[email-masked]>
Date: Wed, 16 Nov 2011 21:39:12 +0800

RPL host or RPL leaf - the argument is the same. A host is a device that would never want to or care about routing. That I exactly what you describe as a RPL leaf.

---

From: Jonathan Hui <[email-masked]>
Date: Wed, 16 Nov 2011 05:40:34 -0800

With my proposed definition, a RPL Leaf is a RPL Router.  A RPL Leaf still operates and participates in the RPL routing protocol - it just happens not to have any children.

--
Jonathan Hui

---

From: Thomas Heide Clausen <[email-masked]>
Date: Wed, 16 Nov 2011 21:49:14 +0800

> With my proposed definition, a RPL Leaf is a RPL Router.  A RPL Leaf still operates and participates in the RPL routing protocol - it just happens not to have any children.

So it just happens to be a particular "accidental" topological position of a router, but entails no different state, transitions or parameters than any other RPL router.

Therefore, there is absolutely no need for another term, it is just an RPL router.

I therefore strongly suggest that there is no reason to invent yet another piece of confusing terminology (and, in general, that ROLL would do well by trying to adhere to standard Internet terminology)

Thomas

---

From: Mukul Goyal <[email-masked]>
Date: Wed, 16 Nov 2011 07:49:25 -0600 (CST)

I agree. 

Thanks
Mukul

----- Original Message -----
From: "Jonathan Hui" <[email-masked]>
To: "Thomas Heide Clausen" <[email-masked]>
Cc: "Mukul Goyal" <[email-masked]>, "roll" <[email-masked]>
Sent: Wednesday, November 16, 2011 7:40:34 AM
Subject: Re: [Roll] definition of "RPL Domain"

--
Jonathan Hui

---

From: Jonathan Hui <[email-masked]>
Date: Wed, 16 Nov 2011 05:53:28 -0800

It may or may not be accidental.  It is perfectly acceptable for a device operating RPL not to advertise routes for destinations other than itself.  Either way, the node still operates RPL.

--
Jonathan Hui

---

From: Thomas Heide Clausen <[email-masked]>
Date: Wed, 16 Nov 2011 21:57:17 +0800

Yes, but is there a node, connected to and in an RPL deployment, that doesn't run RPL? In other words, is there a host in a RPL network?

---

From: "Angelo P. Castellani" <[email-masked]>
Date: Wed, 16 Nov 2011 14:56:01 +0100

> RPL domain: set of devices using RPL as a routing protocol.

and something like:
-- set of router devices in a local area network belonging to the same
administrative domain. multiple RPL domains can be formed inside a
single administrative domain for different purposes.

Best,
Angelo

---

From: Jonathan Hui <[email-masked]>
Date: Wed, 16 Nov 2011 06:02:50 -0800

There may be.  If so, those hosts do not operate any routing protocols (unless you consider ND to be a routing protocol) and are not a part of a RPL domain (under my proposed definition).

--
Jonathan Hui

---

From: C Chauvenet <[email-masked]>
Date: Wed, 16 Nov 2011 06:14:11 -0800

I agree with Jonathan definition.
I think it is quite clear.

Thomas, could you point us to the document where "RPL Host" is used or defined ?

Cédric.

-----Message d'origine-----
De : [email-masked] [mailto:[email-masked]] De la part de Jonathan Hui
Envoyé : mercredi 16 novembre 2011 15:03
À : Thomas Heide Clausen
Cc : roll
Objet : Re: [Roll] definition of "RPL Domain"

--
Jonathan Hui

On Nov 16, 2011, at 5:57 AM, Thomas Heide Clausen wrote:

>>> I therefore strongly suggest that there is no reason to invent yet 
>>> another piece of confusing terminology (and, in general, that ROLL 
>>> would do well by trying to adhere to standard Internet terminology)
>>> 
>>> Thomas
>>> 
>>>> --
>>>> Jonathan Hui
>>>> 
>>>>>>>>> The RPL protocol requires data-plane datagrams to carry RPL 
>>>>>>>>> routing information that is processed by RPL routers when 
>>>>>>>>> forwarding those datagrams.  This document describes the RPL 
>>>>>>>>> Option for use within a RPL domain.
>>>>>>>>> 
>>>>>>>>> 
>>>>>>>>> --------------------------------------------------------------
>>>>>>>>> ------ IETF IPv6 working group mailing list [email-masked] 
>>>>>>>>> Administrative Requests: 
>>>>>>>>> https://www.ietf.org/mailman/listinfo/ipv6
>>>>>>>> ---------------------------------------------------------------
>>>>>>>> ----- IETF IPv6 working group mailing list [email-masked] 
>>>>>>>> Administrative Requests: 
>>>>>>>> https://www.ietf.org/mailman/listinfo/ipv6

---

From: Thomas Heide Clausen <[email-masked]>
Date: Wed, 16 Nov 2011 22:19:08 +0800

> Thomas, could you point us to the document where "RPL Host" is used or defined ?

No, I can't, i didn't bring up the term on the list, I reacted to somebody else bringing it up.

I am trying to understand:

   o why there is a need to invent RPL leaf and RPL router as different terms, 
      what the difference between those two is.

   o if a RPL routed LLN contains hosts, i.e., respects the usual host/router dichotomy.

Thomas 

>>>>>>>>>> ------
>>>>>>>>> -----

---

From: "Dijk, Esko" <[email-masked]>
Date: Wed, 16 Nov 2011 15:31:52 +0000

For information, roll-rpl-19 does define the term "host": an LLN device that can generate but does not forward RPL traffic.

"RPL traffic" is not explicitly defined but should be interpreted as any traffic routed by means of the RPL protocol over a RPL Instance.

regards,
Esko

-----Original Message-----
From: [email-masked] [mailto:[email-masked]] On Behalf Of C Chauvenet
Sent: Wednesday 16 November 2011 15:14
To: Jonathan Hui; Thomas Heide Clausen
Cc: roll
Subject: Re: [Roll] definition of "RPL Domain"

Cédric.

-----Message d'origine-----
De : [email-masked] [mailto:[email-masked]] De la part de Jonathan Hui
Envoyé : mercredi 16 novembre 2011 15:03
À : Thomas Heide Clausen
Cc : roll
Objet : Re: [Roll] definition of "RPL Domain"

--
Jonathan Hui

________________________________
The information contained in this message may be confidential and legally protected under applicable law. The message is intended solely for the addressee(s). If you are not the intended recipient, you are hereby notified that any use, forwarding, dissemination, or reproduction of this message is strictly prohibited and may be unlawful. If you are not the intended recipient, please contact the sender by return e-mail and destroy all copies of the original message.

---

From: Don Sturek <[email-masked]>
Date: Wed, 16 Nov 2011 07:39:10 -0800

Hi Esko,

I would certainly hope that a "host" need not be defined as "an LLN device
that can generate but does not forward RPL traffic".

The definition from Jonathan Hui earlier in this thread makes more sense.
 A RPL domain ends with a RPL leaf node which is by definition a router.
A host only device (one would hope) would not need to know anything about
RPL and would not be considered part of the RPL domain (but would be able
to use a nearby device in the RPL domain to route its packets).

Don

On 11/16/11 7:31 AM, "Dijk, Esko" <[email-masked]> wrote:

>For information, roll-rpl-19 does define the term "host": an LLN device
>that can generate but does not forward RPL traffic.
>
>"RPL traffic" is not explicitly defined but should be interpreted as any
>traffic routed by means of the RPL protocol over a RPL Instance.
>
>regards,
>Esko
>
>There may be.  If so, those hosts do not operate any routing protocols
>(unless you consider ND to be a routing protocol) and are not a part of a
>RPL domain (under my proposed definition).
>
>--
>Jonathan Hui
>
>> Yes, but is there a node, connected to and in an RPL deployment, that
>>doesn't run RPL? In other words, is there a host in a RPL network?
>>
>> --
>> Thomas Heide Clausen
>>> It may or may not be accidental.  It is perfectly acceptable for a
>>>device operating RPL not to advertise routes for destinations other
>>>than itself.  Either way, the node still operates RPL.
>>>
>>> --
>>> Jonathan Hui
>>>
>>>>> With my proposed definition, a RPL Leaf is a RPL Router.  A RPL Leaf
>>>>>still operates and participates in the RPL routing protocol - it just
>>>>>happens not to have any children.
>>>>
>>>> So it just happens to be a particular "accidental" topological
>>>>position of a router, but entails no different state, transitions or
>>>>parameters than any other RPL router.
>>>>
>>>>>>>> Now that we are at it: what is an RPL host? Or rather, why is
>>>>>>>>this even a conceivable thing to define? Afaik, RPL is a routing
>>>>>>>>protocol, and as such should concern only routers - not hosts?
>>>>>>>
>>>>>>> My bad. By RPL host, I actually meant an RPL leaf node. I think
>>>>>>>this term "RPL host" was in use at one point in time but I cant
>>>>>>>find a reference to it in current spec.
>>>>>>
>>>>>>> Now that we are at it: what is an RPL host? Or rather, why is this
>>>>>>>even a conceivable thing to define? Afaik, RPL is a routing
>>>>>>>protocol, and as such should concern only routers - not hosts?
>>>>>>>
>>>>>>> I worry if this is inventing an entire ecosystem which "pretends
>>>>>>>to be just like the Internet, except it is not", as it needs
>>>>>>>entirely new stacks, protocols, translators/gateways everywhere,
>>>>>>>and with no real traces of IP as we know it remaining?
>>>>>>>
>>>>>>> --
>>>>>>> Thomas Heide Clausen
>>>>>>>> 1. It is clear that RPL hosts and routers (as defined towards the
>>>>>>>>end of terminology section in RPL-19) are within an RPL domain but
>>>>>>>>what about the RPL-unaware IPv6 hosts attached to an RPL
>>>>>>>>router/host? I would imagine that such hosts are also within an
>>>>>>>>RPL domain.
>>>>>>>>
>>>>>>>> 2. Is an RPL domain same as an RPL instance? Or is an RPL domain
>>>>>>>>a set of RPL instances in the LLN? Can multiple RPL domains exist
>>>>>>>>within an LLN? Or is it that an RPL domain is same as an LLN using
>>>>>>>>RPL as a routing protocol?
>>>>>>>>
>>>>>>>> Thanks
>>>>>>>> Mukul
>>>>>>>>
>>>>>>>>> I would imagine that it includes all nodes that are downstream
>>>>>>>>>of the RPL border router. But can you clarify if Host nodes that
>>>>>>>>>are downstream of the border router but do not implement any part
>>>>>>>>>of RPL ( even as RPL Leaf nodes ) should be considered part of
>>>>>>>>>the "RPL domain" ?
>>>>>>>>>
>>>>>>>>> In section 5, the draft now says "..Datagrams destined to nodes
>>>>>>>>>outside the RPL domain are dropped if the outer-most IPv6 header
>>>>>>>>>contains a RPL Option..."
>>>>>>>>>
>>>>>>>>> This text would imply that any RPL node sending packets to nodes
>>>>>>>>>outside should always tunnel to the Root ? Is that the intention
>>>>>>>>>really or am I missing something here..
>>>>>>>>>
>>>>>>>>> Also note that if non-RPL Host is not considered part of the RPL
>>>>>>>>>domain, then I am not sure that a forwarding router can know if
>>>>>>>>>the destination is inside the domain or not.
>>>>>>>>>
>>>>>>>>>
>>>>>>>>> -Regards, Joseph
>>>>>>>>>
>>>>>>>>>
>>>>>>>>>> A New Internet-Draft is available from the on-line
>>>>>>>>>>Internet-Drafts directories. This draft is a work item of the
>>>>>>>>>>IPv6 Maintenance Working Group of the IETF.
>>>>>>>>>>
>The information contained in this message may be confidential and legally
>protected under applicable law. The message is intended solely for the
>addressee(s). If you are not the intended recipient, you are hereby
>notified that any use, forwarding, dissemination, or reproduction of this
>message is strictly prohibited and may be unlawful. If you are not the
>intended recipient, please contact the sender by return e-mail and
>destroy all copies of the original message.
>

---

From: Juergen Schoenwaelder <[email-masked]>
Date: Wed, 16 Nov 2011 16:56:47 +0100

> "RPL traffic" is not explicitly defined but should be interpreted as any traffic routed by means of the RPL protocol over a RPL Instance.

So does a host that does not talk RPL and simply sends an IPv6 packet
to a default router, which happens to be an RPL router, generate "RPL
traffic"? This is how I read this. If so, is the host aware in any way
of the fact that it is generating RPL traffic, that is, there there is
RPL used to construct some portions of the path?

I would have naively interpreted "RPL traffic" as the RPL control
traffic, that is the DIO etc. messages being exchanged between RPL
router.

/js

-- 
Juergen Schoenwaelder           Jacobs University Bremen gGmbH
Phone: +49 421 200 3587         Campus Ring 1, 28759 Bremen, Germany
Fax:   +49 421 200 3103         <http://www.jacobs-university.de/>

---

From: Thomas Heide Clausen <[email-masked]>
Date: Thu, 17 Nov 2011 00:11:42 +0800

+1 to what Don says here. 

I would very much like to know if this is the case (and, then, get rid of the invented terms "host" and "RPL leaf" as they seem useless). 

I also would like to know what exactly "RPL Traffic" is?

Thomas

-- 
Thomas Heide Clausen
http://www.thomasclausen.org

"Today's scientists have substituted mathematics for 
  experiments, and they wander off through equation 
  after equation, and eventually  build a structure 
  which has no relation to reality."
 - Nikola Tesla, 
    Modern Mechanics and Inventions, July, 1934

---

From: Mukul Goyal <[email-masked]>
Date: Wed, 16 Nov 2011 10:36:43 -0600 (CST)

I think the term "RPL traffic" actually means just "data traffic". If that is so, the term "RPL traffic" should be replaced by "data traffic".  

RPL control traffic does not need forwarding. All RPL control messages (except DAO, DAO-ACK) are 1-hop. DAO/DAO-ACK messages, even though they may travel multiple hops, travel by unicast. So, RPL routers, when forwarding these messages, are not aware that these messages are actually RPL control messages.

Thanks
Mukul

----- Original Message -----
From: "Juergen Schoenwaelder" <[email-masked]>
To: "Esko Dijk" <[email-masked]>
Cc: "roll" <[email-masked]>
Sent: Wednesday, November 16, 2011 9:56:47 AM
Subject: Re: [Roll] definition of "RPL Domain"

/js

---

From: Philip Levis <[email-masked]>
Date: Wed, 16 Nov 2011 09:29:43 -0800

> I also would like to know what exactly "RPL Traffic" is?

Thomas -- what do you think of Jonathan's suggestion (Don supports it)?

I'm wondering if this discussion can be a little more constructive: rather than shoot down every suggestion that comes up, perhaps you could suggest what you think RPL Traffic is?

Phil

---

From: Thomas Heide Clausen <[email-masked]>
Date: Thu, 17 Nov 2011 01:42:45 +0800

Phil,

I have actually no idea what "RPL Traffic" is, hence my question.  

I don't think that a random guess from me would be particularly constructive, would it?

Thomas

---

From: Don Sturek <[email-masked]>
Date: Wed, 16 Nov 2011 09:46:51 -0800

Here is my suggestion for "RPL traffic" (if indeed we find we even need
the term in the RFC/draft):

RPL traffic ==  Data traffic which transits routers that determined the
routing path via RPL control messages.

Don

On 11/16/11 9:29 AM, "Philip Levis" <[email-masked]> wrote:

>> I would very much like to know if this is the case (and, then, get rid
>>of the invented terms "host" and "RPL leaf" as they seem useless).
>> 
>I'm wondering if this discussion can be a little more constructive:
>rather than shoot down every suggestion that comes up, perhaps you could
>suggest what you think RPL Traffic is?
>
>Phil

---

From: Mukul Goyal <[email-masked]>
Date: Wed, 16 Nov 2011 12:07:00 -0600 (CST)

Hi Sebastien

First, I would like to clarify that the need to define "RPL domain" arose because draft-ietf-6man-rpl-option and draft-ietf-6man-rpl-routing-header were using the term. Now, these drafts use the term "RPL instance" and hence there is no real need to define the term "RPL domain" any more. I will change draft-ietf-roll-p2p-measurement so that all references to "RPL domain" are changed to "RPL Instance".

Now returning to the question whether hosts should be considered part of the RPL Instance, the benefit of doing so is that there is no need to use IP-in-IP tunneling when a host sends out some data. If a host is not considered part of the RPL Instance, its default RPL router is obliged to use IP-in-IP tunneling to forward the packet further. IP-in-IP tunneling means an extra IPv6 header and thus less space for payload if you want to avoid fragmentation. Also, if the packet is traveling along a DAG, the encapsulation/decapsulation needs to be done at every hop, which sounds fairly heavy duty processing to me.

So, I would like to explore if there is a way we could consider hosts to be a part of the RPL Instance.

Regards,
Mukul

---

From: Mukul Goyal <[email-masked]>
Date: Wed, 16 Nov 2011 12:29:59 -0600 (CST)

Hi Don

I dont want hosts to know about RPL. I just want the RPL routers to consider the hosts as part of the RPL instance so that the RPL router does not have to do IP-in-IP tunneling to forward packets generated by a host.

Thanks
Mukul

----- Original Message -----
From: "Don Sturek" <[email-masked]>
To: "Mukul Goyal" <[email-masked]>, "Sébastien Dawans" <[email-masked]>
Cc: [email-masked]
Sent: Wednesday, November 16, 2011 12:22:55 PM
Subject: Re: [Roll] definition of "RPL Domain"

Hi Mukul,

I guess my view on this is the opposite of yours.  I would like to see
host-only devices not need to know anything about RPL.  Here is why:
1)  Code savings.   Removing RPL from these host only devices would allow
for deployment on smaller footprint devices
2)  Battery operated devices.   Some host only devices are deployed on
non-mains powered devices.  It would be nice for these devices to not have
to listen for any RPL control messages yet still support transmission into
a RPL routing domain.

Don

On 11/16/11 10:07 AM, "Mukul Goyal" <[email-masked]> wrote:

>Hi Sebastien
>
>First, I would like to clarify that the need to define "RPL domain" arose
>because draft-ietf-6man-rpl-option and draft-ietf-6man-rpl-routing-header
>were using the term. Now, these drafts use the term "RPL instance" and
>hence there is no real need to define the term "RPL domain" any more. I
>will change draft-ietf-roll-p2p-measurement so that all references to
>"RPL domain" are changed to "RPL Instance".
>
>Now returning to the question whether hosts should be considered part of
>the RPL Instance, the benefit of doing so is that there is no need to use
>IP-in-IP tunneling when a host sends out some data. If a host is not
>considered part of the RPL Instance, its default RPL router is obliged to
>use IP-in-IP tunneling to forward the packet further. IP-in-IP tunneling
>means an extra IPv6 header and thus less space for payload if you want to
>avoid fragmentation. Also, if the packet is traveling along a DAG, the
>encapsulation/decapsulation needs to be done at every hop, which sounds
>fairly heavy duty processing to me.
>
>> 1. It is clear that RPL routers are within an RPL domain but what about
>>the RPL-unaware IPv6 hosts attached to an RPL router? I would imagine
>>that such hosts are also within an RPL domain.
>>
>> 2. Is an RPL domain same as an RPL instance? Or is an RPL domain a set
>>of RPL instances in the LLN? Can multiple RPL domains exist within an
>>LLN? Or is it that an RPL domain is same as an LLN using RPL as a
>>routing protocol?
>>
>> THanks
>> Mukul
>>
>>>even a conceivable thing to define? Afaik, RPL is a routing protocol,
>>>and as such should concern only routers - not hosts?
>>>      
>> My bad. By RPL host, I actually meant an RPL leaf node. I think this
>>term "RPL host" was in use at one point in time but I cant find a
>>reference to it in current spec.
>>
>> THanks
>> Mukul
>>
>>
>>
>> Now that we are at it: what is an RPL host? Or rather, why is this even
>>a conceivable thing to define? Afaik, RPL is a routing protocol, and as
>>such should concern only routers - not hosts?
>>
>> I worry if this is inventing an entire ecosystem which "pretends to be
>>just like the Internet, except it is not", as it needs entirely new
>>stacks, protocols, translators/gateways everywhere, and with no real
>>traces of IP as we know it remaining?
>>
>>    
>

---

From: Don Sturek <[email-masked]>
Date: Wed, 16 Nov 2011 10:22:55 -0800

Hi Mukul,

Don

---

From: Mukul Goyal <[email-masked]>
Date: Wed, 16 Nov 2011 12:38:15 -0600 (CST)

I guess the desired behavior would be:

A host sends out a message to its RPL router. The router adds RPL SRH or RPL option to the IPv6 header and forwards the message further. No need for IP-in-IP tunneling. Any error message comes back to the router and the router handles the message. The host just sends and receives messages.

Thanks
Mukul

----- Original Message -----
From: "Mukul Goyal" <[email-masked]>
To: "Don Sturek" <[email-masked]>
Cc: [email-masked]
Sent: Wednesday, November 16, 2011 12:29:59 PM
Subject: Re: [Roll] definition of "RPL Domain"

Hi Don

Thanks
Mukul

----- Original Message -----
From: "Don Sturek" <[email-masked]>
To: "Mukul Goyal" <[email-masked]>, "Sébastien Dawans" <[email-masked]>
Cc: [email-masked]
Sent: Wednesday, November 16, 2011 12:22:55 PM
Subject: Re: [Roll] definition of "RPL Domain"

Hi Mukul,

Don

---

From: Ulrich Herberg <[email-masked]>
Date: Thu, 17 Nov 2011 09:00:06 +0800

My 2cts on the various terminology discussions:

- An "RPL host" seems contradictory to me. Either it is a host, in which case it does not know anything about RPL, or it is an RPL router (leaf node or not, it still remains a router). We should allow for hosts (or be prepared to fight with the IAB for the next years why we think that we should break the IP architecture).

- A question that comes to my mind: Is it specified anywhere how to add the RPL IP headers for the traffic direction to a data packet from a host received by an RPL router?

- "RPL domain"; We should just stick to official terminology, i.e, "Routing Domain" in this case. I think it has been specified in RFC1136.

- RPL traffic: I don't like the term. I would stick to either control traffic or data traffic. Everyone understands these terms. No need to invent new terms.

Regards
Ulrich

---

From: Yvonne-Anne Pignolet <[email-masked]>
Date: Thu, 17 Nov 2011 17:13:38 +0100

I fully agree with Ulrich

Yvonne-Anne Pignolet
Dr. Sc. ETH
ABB Schweiz AG
Segelhofstrasse 1K
5400 Baden-Dättwil, Switzerland
Phone: +41 58 586 86 56
Mobile: +41 79 766 10 54
email: [email-masked]

[email-masked] wrote on 17.11.2011 02:00:06:

> From: Ulrich Herberg <[email-masked]>
> To: Mukul Goyal <[email-masked]>
> Cc: "[email-masked]" <[email-masked]>
> Date: 17.11.2011 01:59
> Subject: Re: [Roll] Hosts part of the RPL instance? Re: definition 
> of "RPL Domain"
> Sent by: [email-masked]
> 
> - An "RPL host" seems contradictory to me. Either it is a host, in 
> which case it does not know anything about RPL, or it is an RPL 
> router (leaf node or not, it still remains a router). We should 
> allow for hosts (or be prepared to fight with the IAB for the next 
> years why we think that we should break the IP architecture).
> 
> - A question that comes to my mind: Is it specified anywhere how to 
> add the RPL IP headers for the traffic direction to a data packet 
> from a host received by an RPL router?
> 
> - "RPL domain"; We should just stick to official terminology, i.e, 
> "Routing Domain" in this case. I think it has been specified in RFC1136.
> 
> - RPL traffic: I don't like the term. I would stick to either 
> control traffic or data traffic. Everyone understands these terms. 
> No need to invent new terms.
> 
> Regards
> Ulrich
> 
> > A host sends out a message to its RPL router. The router adds RPL 
> SRH or RPL option to the IPv6 header and forwards the message 
> further. No need for IP-in-IP tunneling. Any error message comes 
> back to the router and the router handles the message. The host just
> sends and receives messages.
> > 
> > Thanks
> > Mukul
> > 
> > I dont want hosts to know about RPL. I just want the RPL routers 
> to consider the hosts as part of the RPL instance so that the RPL 
> router does not have to do IP-in-IP tunneling to forward packets 
> generated by a host.
> > 
> > Thanks
> > Mukul
> > 
> >> So, I would like to explore if there is a way we could consider hosts 
to
> >> be a part of the RPL Instance.
> >> 
> >> Regards,
> >> Mukul
> >> 
protocol,
> >>> Now that we are at it: what is an RPL host? Or rather, why is this 
even

---

From: Emmanuel Baccelli <[email-masked]>
Date: Thu, 17 Nov 2011 17:25:06 +0100

I also agree with Ulrich, i.e. to keep the usual definitions of hosts,
routers and routing domain. An RPL routing domain would then naturally be a
routing domain where the routing protocol in use is RPL. Thus, is there a
need for any particular new definition?
cheers
Emmanuel

On Thu, Nov 17, 2011 at 5:13 PM, Yvonne-Anne Pignolet <
[email-masked]> wrote:

>   *Yvonne-Anne Pignolet*
> email: [email-masked]* <[email-masked]>
>
>

---

From: Robert Cragie <[email-masked]>
Date: Thu, 17 Nov 2011 16:47:19 +0000

+1

The only consideration which we may need is the concept of a 'LLN host', 
i.e. one which is sleepy. In this case the parent router (protocol 
indeterminate) may need to buffer data for it. However this is nothing 
to do with RPL or any routing protocol but does fall into the ND area of 
discussion.

Robert

On 17/11/2011 1:00 AM, Ulrich Herberg wrote:
> On Nov 17, 2011, at 2:38, Mukul Goyal<[email-masked]>  wrote:
>
>> To: "Don Sturek"<[email-masked]>
>> Cc: [email-masked]
>> From: "Don Sturek"<[email-masked]>
>> To: "Mukul Goyal"<[email-masked]>, "Sébastien Dawans"<[email-masked]>
>> Cc: [email-masked]
>> On 11/16/11 10:07 AM, "Mukul Goyal"<[email-masked]>  wrote:
>>
>>> Hi Sebastien
>>>

---

From: Jonathan Hui <[email-masked]>
Date: Thu, 17 Nov 2011 12:32:51 -0800

There case where you want to be a bit more specific.

The following phrases should be unambiguous by now:
- RPL routing domain
- RPL control/data traffic

Can we move on now?

--
Jonathan Hui

---

From: Mukul Goyal <[email-masked]>
Date: Thu, 17 Nov 2011 21:10:07 -0600 (CST)

I agree with this definition of RPL domain. The definition implies that RPL devices may have links/interfaces that are considered exterior to the RPL domain.

Thanks
Mukul

----- Original Message -----
From: "Jonathan Hui" <[email-masked]>
To: "Mukul Goyal" <[email-masked]>
Cc: "JP Vasseur" <[email-masked]>, "roll" <[email-masked]>
Sent: Wednesday, November 16, 2011 7:37:32 AM
Subject: Re: [Roll] definition of "RPL Domain"

--
Jonathan Hui

---

From: Mukul Goyal <[email-masked]>
Date: Thu, 24 Nov 2011 12:29:45 -0600 (CST)

Hi Jonathan, JP

Just wondering if you could confirm that the next version of the terminology draft will have this definition of RPL domain included. This would allow me to refer to the terminology draft for the definition of RPL domain in the p2p-measurement draft.

Thanks
Mukul

----- Original Message -----
From: "Mukul Goyal" <[email-masked]>
To: "Jonathan Hui" <[email-masked]>
Cc: "roll" <[email-masked]>
Sent: Thursday, November 17, 2011 9:10:07 PM
Subject: Re: [Roll] definition of "RPL Domain"

Thanks
Mukul

----- Original Message -----
From: "Jonathan Hui" <[email-masked]>
To: "Mukul Goyal" <[email-masked]>
Cc: "JP Vasseur" <[email-masked]>, "roll" <[email-masked]>
Sent: Wednesday, November 16, 2011 7:37:32 AM
Subject: Re: [Roll] definition of "RPL Domain"

--
Jonathan Hui

---

From: JP Vasseur <[email-masked]>
Date: Fri, 25 Nov 2011 14:47:00 +0100

Hi,

> Just wondering if you could confirm that the next version of the terminology draft will have this definition of RPL domain included. This would allow me to refer to the terminology draft for the de…

Nice, I'll summarize the discussion and make sure that everybody agrees before submitting (soon).

Thanks.

JP.